<template>
  <div>
    <TemplateStartModal
      :open="isTemplateStartModalVisible"
      :resource-form="resourceForm"
      @close="templateStartModalClose"
      @next="extractMetadata"
    />
    <TemplateLoadingModal
      :open="isTemplateLoadingModalVisible"
      @close="templateLoadingModalClose"
    />
    <TemplateApplyModal
      :open="isTemplateApplyModalVisible"
      :application-profile="applicationProfile"
      :extracted-metadata="extractedMetadata"
      :fixed-values="fixedValues"
      @close="templateApplyModalClose"
      @next="confirmTemplate"
      @update:fixed-values="inputFixedValues"
    />
  </div>
</template>

<script lang="ts">
import useMetadataExtractionStore from "./store";

import TemplateStartModal from "./TemplateStartModal.vue";
import TemplateLoadingModal from "./TemplateLoadingModal.vue";
import TemplateApplyModal from "./TemplateApplyModal.vue";

import type { ResourceForUpdateDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type {
  ApplicationProfileDefinition,
  FixedValuesForResource,
} from "../../../../types";
import type { Dataset } from "@rdfjs/types";
import type { FixedValues } from "@coscine/form-generator/dist/types/fixedValues";

export default defineComponent({
  components: {
    TemplateStartModal,
    TemplateLoadingModal,
    TemplateApplyModal,
  },

  props: {
    applicationProfile: {
      type: [Object, null] as PropType<ApplicationProfileDefinition | null>,
      default: null,
    },
    resourceForm: {
      type: Object as PropType<ResourceForUpdateDto>,
      required: true,
    },
    open: {
      type: Boolean,
      required: true,
    },
  },

  emits: {
    close: () => true,
    "update:modelValue": (_: FixedValuesForResource) => true,
  },

  setup() {
    const metadataExtractionStore = useMetadataExtractionStore();

    return { metadataExtractionStore };
  },

  data() {
    return {
      extractedMetadata: null as Dataset | null,
      fixedValues: undefined as FixedValues | undefined,

      isTemplateStartModalVisible: false,
      isTemplateLoadingModalVisible: false,
      isTemplateApplyModalVisible: false,

      loadingExtractedMetadata: false,
    };
  },

  watch: {
    open() {
      if (this.open) {
        this.isTemplateStartModalVisible = true;
        this.fixedValues = this.resourceForm.fixedValues as FixedValues;
      }
    },
  },

  methods: {
    confirmTemplate() {
      if (this.fixedValues) {
        this.$emit("update:modelValue", this.fixedValues);
      }

      this.isTemplateApplyModalVisible = false;
      this.$emit("close");
    },
    async extractMetadata(file: File) {
      this.isTemplateStartModalVisible = false;
      this.isTemplateLoadingModalVisible = true;
      this.loadingExtractedMetadata = true;

      try {
        const extractedMetadata =
          await this.metadataExtractionStore.extractMetadata(file);

        if (extractedMetadata === null) {
          this.$emit("close");
          return;
        }

        this.extractedMetadata = extractedMetadata;

        // If loading modal is not visible, template has been canceled
        if (this.isTemplateLoadingModalVisible) {
          this.isTemplateApplyModalVisible = true;
        }
      } catch {
        this.$emit("close");
      } finally {
        this.loadingExtractedMetadata = false;
        this.isTemplateLoadingModalVisible = false;
      }
    },
    inputFixedValues(fixedValues: FixedValuesForResource) {
      this.fixedValues = fixedValues;
    },

    templateStartModalClose() {
      this.isTemplateStartModalVisible = false;
      // No other modal displayed => aborted
      if (
        !this.isTemplateLoadingModalVisible &&
        !this.isTemplateApplyModalVisible
      ) {
        this.$emit("close");
      }
    },
    templateLoadingModalClose() {
      this.isTemplateLoadingModalVisible = false;
      // If still loading, means user aborted
      if (this.loadingExtractedMetadata) {
        this.$emit("close");
      }
    },
    templateApplyModalClose() {
      this.isTemplateApplyModalVisible = false;
      this.$emit("close");
    },
  },
});
</script>
